#ifndef MATRIX_H
#define MATRIX_H

#include "Arduino.h"

#define RGB_PORT              PORTA
#define RGB_PORT_DDR          DDRA

#define DECODER_PORT          PORTF
#define DECODER_PORT_DDR      DDRF

#define SHIFT_CLK_PORT        PORTB
#define SHIFT_CLK_PORT_DDR    DDRB
#define SHIFT_CLK_PIN         5

#define SHIFT_LATCH_PORT      PORTB
#define SHIFT_LATCH_PORT_DDR  DDRB
#define SHIFT_LATCH_PIN       4

#define SHIFT_OE_PORT         PORTH
#define SHIFT_OE_PORT_DDR     DDRH
#define SHIFT_OE_PIN          6
                                                                      
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))  
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#define GPIO_WritePin(port,pin,level) level?sbi(port,pin):cbi(port,pin)

typedef enum{
  BLACK,
  RED,
  GREEN,
  YELLOW,
  BLUE,
  PURPLE,
  CYAN,
  WHITE
}COLOR;

extern volatile COLOR RGB_ARRAY[16][128];  

void init_matrix();

void __DECODER_SET(uint8_t data);

void __SHIFT_OUT(uint8_t line);

void __DYNAMIC_IDICATION(void);

void matrix_fill(COLOR color);

void matrix_draw_pixel(int16_t x, int16_t y, COLOR color);

void matrix_draw_print_char_7x5(int16_t x, int16_t y, uint8_t color, char _char);

void matrix_draw_print_7x5(int16_t x, int16_t y, uint8_t color, char* text);

void matrix_draw_print_char_7x5_scaled(int16_t x, int16_t y, uint8_t color, char _char, uint8_t scale);

void matrix_draw_print_7x5_scaled(int16_t x, int16_t y, uint8_t color, char* text, uint8_t scale);

#endif
