#include "matrix.h"
#include "math.h"
                                              
#define DEBUG

uint32_t text_speed = 150;   

int16_t getTextSize(char* text){
  int16_t len = 0;
  for(uint8_t i=0;i<255;i++){
    if(text[i]==0x0D || text[i]==0x00){
      len=i*2;             
      break;
    }
  }
  return len;
}

void setup() {
  Serial.begin(115200);
  
  init_matrix();
  sbi(DDRE,4);
  
    // инициализация Timer3
    cli(); // отключить глобальные прерывания
    TCCR3A = 0; // установить регистры в 0
    TCCR3B = 0; 

    OCR3A = 0; // установка регистра совпадения
    TCCR3B |= (1 << WGM12); // включение в CTC режим

    // Установка битов CS10 и CS12 на коэффициент деления 1024
    TCCR3B |= (1 << CS10);
    TCCR3B |= (1 << CS12);

    TIMSK3 |= (1 << OCIE1A);  // включение прерываний по совпадению
    sei(); // включить глобальные прерывания

    delay(5000);//Задержка необходима для инициализации таймера
}

//Функция, вызываемая в прерывании для динамической индикации
ISR(TIMER3_COMPA_vect)
{
  static volatile uint8_t itr_brk = 0;
  sbi(PORTE,4);
  if(!itr_brk)__DYNAMIC_IDICATION();
  cbi(PORTE,4);
  itr_brk=(itr_brk+1)%4;
}

void loop() {
  static uint8_t scale = 2;       
  static char text[256]="OPTOELEKTRONIKA";  
  static char serial_buffer[256]={0};
  if(Serial.available()){delay(10);}
  for(uint8_t i=0;Serial.available();i++){
    serial_buffer[i]=Serial.read();
    if(!Serial.available()){
      if(serial_buffer[i]==0x0D && serial_buffer[0]!=0){
        Serial.println("chpOK");
        for(uint8_t j=0;serial_buffer[j]!=0x0D && j<255;j++){text[j]=serial_buffer[j];}
        text[i]=serial_buffer[i];
        matrix_fill(BLACK);
      }else{
        serial_buffer[0]=0;
      }
    }
  }
  
  if((getTextSize(text)*(6*scale))>204){
    matrix_fill(BLACK);
  }else{
    matrix_draw_print_7x5_scaled((158-(getTextSize(text)*9*scale))/2+1,(32-(scale*5))/2+1,YELLOW,text,scale); 
  }
}
